/* (C) 2001-2002 Andrew J. Kroll */
/* see file README for license details */

#include <stdlib.h> 
#include <stdio.h>
#include <string.h>
#include "tcpvars.h"
#include "compat.h"


#ifdef SAFEMEMORY
/* just incase the code wedges on an unchecked malloc... */
void * safemalloc(nw)
size_t nw;
{
	void * nm;
	printf("SAFE MALLOC of %i bytes\n", nw);
	nm = malloc(nw);
	if(nm == NULL) {
		printf("Out of memory\n");
		exit(1);
	}
	printf("Success!\n_M_ %lx < \n", (unsigned long)nm);
	fflush(stdout);
	return(nm);
}
/* just incase the code wedges on an unchecked realloc... */
void * REALLOC(om, nw)
void * om;
size_t nw;
{
	void * nm;
	printf("SAFE REALLOC of %i bytes\n_O_ %lx < \n", nw, (unsigned long)om);
	fflush(stdout);
	if(om == NULL) {
		printf("Realloc of NULL attempted!\n");
		exit(1);
	}
	nm = realloc(om, nw);
	if(nm == NULL) {
		printf("Out of memory\n");
		exit(1);
	}
	printf("Success!\n_R_ %lx < \n", (unsigned long)nm);
	fflush(stdout);
	return(nm);
}

void FREE(nm)
void *nm;
{
	printf("Free\n_F_ %lx > \n", (unsigned long)nm);
	free(nm);

}
#endif

/* very simple terse usage */
void AJKNETusage(Fprgogname, version, Fexecute, programname, syntax)
char *Fprgogname;
char *version;
char *Fexecute;
char *programname;
char *syntax;
{

/* Because HI-TECH C can't do argv[0]!!! */
#ifdef HI_TECH_C
#ifdef CPM
#ifdef z80
	printf("\n%s, Version %s\nStack Version %s\n\n",Fprgogname,version,STACKVERSION);
	printf("Syntax:\n%s %s\n\n",Fprgogname,syntax);
#endif
#endif
#else
	printf("\n%s, Version %s\nStack Version %s\n\n",programname,version,STACKVERSION);
	printf("Syntax:\n%s %s\n\n",programname,syntax);

#endif
	exit(1);
}

#ifndef HI_TECH_C
#define HI_TECH_C
#endif

void snag32(from, to)
unsigned char *from;
unsigned char *to;
{
	/* copy block of 4, incase bcopy dosen't exist... */
	to[0] = from[0];
	to[1] = from[1];
	to[2] = from[2];
	to[3] = from[3];
}

void snag16(from, to)
unsigned char *from;
unsigned char *to;
{
	/* copy block of 2, incase bcopy dosen't exist... */
	to[0] = from[0];
	to[1] = from[1];
}


/* simple incrementers... */
void inc32word(workspace)
unsigned char *workspace;
{ 
	workspace[3]++; 
	if(workspace[3] == 0x00) { 
		workspace[2]++; 
		if(workspace[2] == 0x00) { 
		workspace[1]++; 
			if(workspace[1] == 0x00) { 
				workspace[0]++; 
			}
		}
	}
}

void inc32wordLE(workspace)
unsigned char *workspace;
{ 
	workspace[0]++; 
	if(workspace[0] == 0x00) { 
		workspace[1]++; 
		if(workspace[1] == 0x00) { 
		workspace[2]++; 
			if(workspace[2] == 0x00) { 
				workspace[3]++; 
			}
		}
	}
}

void dec32word(workspace)
unsigned char *workspace;
{
	workspace[3]--; 
	if(workspace[3] == 0xff) { 
		workspace[2]--; 
		if(workspace[2] == 0xff) {
			workspace[1]--; 
			if(workspace[1] == 0xff) { 
				workspace[0]--;
			}
		}
	}
}

void inc16word(workspace)
unsigned char *workspace;
{
	workspace[1]++;
	if(workspace[1] == 0x00) workspace[0]++;
}

/* simple returns */
unsigned long ret32word(workspace)
unsigned char *workspace;
{
#ifdef HI_TECH_C
	/* ugly compiler bug work arround */
	unsigned long foo=0;
	unsigned char *bleh = (unsigned char *) &foo;
	bleh[3] = workspace[0];
	bleh[2] = workspace[1];
	bleh[1] = workspace[2];
	bleh[0] = workspace[3];
	return(foo);
#else
	return(workspace[3] + (workspace[2] * 256) + (workspace[1] * 65536) + (workspace[0] * 16777216));
#endif
}

unsigned short ret16word(workspace)
unsigned char *workspace;
{
	return(workspace[1] + (workspace[0] * 256));
}

/* simple stores */
void sav32word(workspace, val)
unsigned char *workspace;
unsigned long val;
{
#ifdef HI_TECH_C
	/* ugly compiler bug work arround */
	unsigned long foo = val;
	unsigned char *bleh = (unsigned char *) &foo;

	workspace[0] = bleh[3];
	workspace[1] = bleh[2];
	workspace[2] = bleh[1];
	workspace[3] = bleh[0];
	                                
#else
	workspace[3] = val & 0xff;
	workspace[2] = (val / 256) & 0xff;
	workspace[1] = (val / 65536) & 0xff;
	workspace[0] = (val / 16777216) & 0xff;
#endif
}

void sav16word(workspace, val)
unsigned char *workspace;
unsigned long val;
{
	workspace[1] = val & 0xff;
	workspace[0] = (val / 256) & 0xff;
}

/* little endian/8bit unsigned */
unsigned long add32word(val1, val2)
unsigned long val1;
unsigned long val2;
{
#ifdef HI_TECH_C
	unsigned long result;
	unsigned char *ptr1;
	unsigned char *ptr2;
	unsigned char *resptr;
	unsigned short bleh;
	unsigned short fuq;
	unsigned short you;
	
	ptr1 = (unsigned char *) &val1;
	ptr2 = (unsigned char *) &val2;
	resptr = (unsigned char *) &result;
	fuq = ptr1[0];
	you = ptr2[0];
	bleh = fuq + you;
	resptr[0] = bleh & 0xff;
	bleh = bleh / 256;
	
	fuq = ptr1[1];
	you = ptr2[1];
	bleh += fuq + you;
	resptr[1] = bleh & 0xff;
	bleh = bleh / 256;
	
	fuq = ptr1[2];
	you = ptr2[2];
	bleh += fuq + you;
	resptr[2] = bleh & 0xff;
	bleh = bleh / 256;
	
	fuq = ptr1[3];
	you = ptr2[3];
	bleh += fuq + you;
	resptr[3] = bleh & 0xff;
	
	return(result);
		
#else
	return(val1 + val2);
#endif
}

/* little endian/8bit unsigned */
unsigned long sub32word(val2, val1)
unsigned long val2;
unsigned long val1;
{
#ifdef HI_TECH_C
	/* 2's complement then add */
	unsigned long result;
	unsigned long final;
	unsigned char *resptr;
	unsigned char *ptr;

	ptr=(unsigned char *) &val2;
	resptr = (unsigned char *) &result;
	/* basically this is an XOR with 0xff :-> */
	resptr[0] = ~ptr[0];
	resptr[1] = ~ptr[1];
	resptr[2] = ~ptr[2];
	resptr[3] = ~ptr[3];
	/* INC */
	inc32wordLE(resptr);
	final = add32word(val1, result);
	return(final);
#else
	return(val1 - val2);
#endif
}

int compare32word(val1, oper, val2)
unsigned long val1;
int oper;
unsigned long val2;
{

#ifdef HI_TECH_C
	/* ugly compiler bug work arround */
	register char a;
	register char b;
	unsigned long foo1 = val1;
	unsigned long foo2 = val2;
	unsigned char *bleh1 = (unsigned char *) &foo1;
	unsigned char *bleh2 = (unsigned char *) &foo2;

	a=0;
	b=1;
	/* note the lack of break useage, it's not nessesary */
	switch (oper) {
		case CMPGT: /* > */
			if(bleh1[0] < bleh2[0]) return(a > b);
			if(bleh1[1] < bleh2[1]) return(a > b);
			if(bleh1[2] < bleh2[2]) return(a > b);
			return(bleh1[3] > bleh2[3]);

		case CMPLT: /* < */
			if(bleh1[0] > bleh2[0]) return(b < a);
			if(bleh1[1] > bleh2[1]) return(b < a);
			if(bleh1[2] > bleh2[2]) return(b < a);
			return(bleh1[3] < bleh2[3]);

		case CMPEQU: /* == */
			return((bleh1[0] == bleh2[0]) && (bleh1[1] == bleh2[1]) && (bleh1[2] == bleh2[2]) && (bleh1[3] == bleh2[3]));

		case CMPNEQ: /* != */
			return((bleh1[0] != bleh2[0]) || (bleh1[1] != bleh2[1]) || (bleh1[2] != bleh2[2]) || (bleh1[3] != bleh2[3]));

		case CMPLEQ: /* <= */
			if(bleh1[0] > bleh2[0]) return(b <= a);
			if(bleh1[1] > bleh2[1]) return(b <= a);
			if(bleh1[2] > bleh2[2]) return(b <= a);
			return(bleh1[3]<=bleh2[3]);

		case CMPGEQ: /* >= */
			if(bleh1[0] < bleh2[0]) return(a >= b);
			if(bleh1[1] < bleh2[1]) return(a >= b);
			if(bleh1[2] < bleh2[2]) return(a >= b);
			return(bleh1[3] >= bleh2[3]);

		default:
			printf("\n\nBAD COMPARE\n\n");
			exit(1);
			break;
	}
#else
	switch (oper) {
		case CMPGT: /* > */
			return(val1 > val2);
		case CMPLT: /* < */
			return(val1 < val2);
		case CMPEQU: /* == */
			return(val1 == val2);
		case CMPNEQ: /* != */
			return(val1 != val2);
		case CMPLEQ: /* <= */
			return(val1 <= val2);
		case CMPGEQ: /* >= */
			return(val1 >= val2);
		default: /* ??? */
			printf("\n\nBAD COMPARE\n\n");
			exit(1);
			break;
	}
	
#endif
}
/* tell link parser who we are and where we belong

1200 libznet.lib compat.obj xxLIBRARYxx

*/

