/* (C) 2001-2002 Andrew J. Kroll */
/* see file README for license details */
/*
   Automatic update/bootstrap.
   Ping and traceroute (normal part of the stack).
   No daemons listening.
*/

/* standard includes */
#include <stdlib.h> 
#include <stdio.h>
#include <string.h>

/* fixups for HI-TECH C, GCC, and probably other compilers. */
#ifdef HI_TECH_C
#include <sys.h>
#include <unixio.h>
#include <conio.h>
#else
#ifdef LINUX
#include <asm/io.h>
#endif
#endif

#include "in.h"
#include "netinet.h"
#include "socket.h"
/* various fixups, os dependent */
#include "compat.h" 
#include "netutil.h"

#define PROGRAM "CPMTELNET"
#define VERSION "0.0.2"
#define EXECUTABLE "TELNET"

/* see if directive was seen, and what stage */
int ffseen = 0;
/* holding data for a telnet response */
unsigned char ffresponse[5];

int sock = -1;


int grabline(uri)
char *uri;
{
	char *ptr;
	int zap = -1;
	int i = 1;
	
	ptr = uri;
	while(i < 96) {
		zap = sockread(sock, ptr, 1);
		if(zap < 0) break;
		if(*ptr == '\n') break;
		if(*ptr != '\r') {
			if(zap == 1) {
				i++;
				ptr++;
			}
		}
	}
	
	*ptr = 0x00;
	return zap;
}

int grabfile(uri, local)
char *uri;
char *local;
{
	int zap = -1;
	int i = 1;
	FILE *dl;
	
	while(strlen(uri)) {
		zap = grabline();
		if(zap < 0) break;
	}
	if(zap > -1) {
		/* read in file and save it */
		dl = fopen(local, "wb");
		if(dl == NULL) {
			zap = -1;
			perror(local);
		} else {
		
			while(i > -1) {
				i = sockread(sock, uri, 96);
				if(i > 0) {
					printf(".");
					fflush(stdout);
					zap = fwrite(uri, 1, i, dl);
					if(zap < 0) break;
				}
			}
			fclose(dl);
			if(zap > -1) {
				printf("Done\n");
			}
		}
	}
	
	return(zap);
}

int doreq(uri, local)
char *uri;
char *local;
{
	int zap;
	char *ptr;

	zap = sockwrite(sock, uri, strlen(uri));
	if(zap > -1) {
		sprintf(uri,"User-Agent: %s/%s (AJKstack/%s, %s, %s)\n\n", PROGRAM, VERSION, STACK_IS, OS, CPU);
		zap = sockwrite(sock, uri, strlen(uri));
	}
	if(zap > -1) {
		zap = grabline(uri);
	}
	if(zap > -1) {
		/* check the result, we must see a 200 here */
		ptr = uri;
		while(*ptr != ' ') ptr++;
		ptr++;
		zap = -1;
		if(*ptr == '2') {
			ptr++;
			if(*ptr == '0') {
				ptr++;
				if(*ptr == '0') {
					printf("%s\n", uri);
					zap = grabfile(uri, local);
				}
			}
		} 
	}
	return(zap);
}



int getfile(host, url, port, dest, local)
char *host;
char *url;
int port;
unsigned char *dest;
char *local;
{
	int zap = -1;
	char information[96];
	
	printf("Contacting %s...", host);
	zap = socket(AF_INET,SOCK_STREAM, 0);
	if(zap > -1) {
		sock = zap;
		zap = sockconnect(sock, port, dest);
		if(zap > -1) {
			printf("\nRequesting file %s...", url);
			sprintf(information,"GET %s HTTP/1.0\n", url);
			zap = doreq(information, local);
		}
		sockclose(sock);
	}
	
	return(zap);
}


void usage(argv)
char *argv[];
{
#define USE "dr.ea.ms"
	AJKNETusage(PROGRAM, VERSION, EXECUTABLE, argv[0], USE);
}

int main(argc, argv)
int argc;
char *argv[];
{
	struct u_nameip *result;
	int zap = -1;
	int dotcount = 0;
	int port = 80;
	char urlbase[80];
	char iodata[81];
	char local[80];
	FILE *ls;

	if(argc != 2) usage(argv);

/* pre check rc file, if none, prompt to make one */

/* IMPORTANT: initialize the network! */
	initnetwork(argc, argv);


	/* snag out the net address.... */
	result = findhost(argv[1], 1);
	if(result == NULL) {
		printf("No such host\n");
	} else {

		/* take each one into a byte :-) */
		sprintf(urlbase,"/update/%1.1x%1.1x%1.1x%1.1x%1.1x%1.1x%1.1x%1.1x%1.1x%1.1x%1.1x000000000/%s", 
		USESIMPLESLIP, USEARCNET, HAVE_RTC, USEZ80DART, USECPM3AUX, USELINUXTTYS, USEELKSTTYS, USEDOSUART, USEZ80SIO, USECOM8116, USESILVER, STACK_IS);

		sprintf(local,"files.txt");
		sprintf(iodata, "%s/%s", urlbase, local);
		
		zap = getfile(result->hostname, iodata, port, result->hostip, local);
		if(zap < 0) goto bail;

		ls = fopen(local, "rb");
		if(ls == NULL) {
			perror(local);
			goto bail;
		}

		while(zap > -1) {
			if(dotcount) break;
			zap = fscanf(ls, "%s\n", local);
			if(zap > -1) {
				if(!strncmp(local, "update", 6)) dotcount = 1;
				if(!strcmp(local, "END")) {
					zap = -1;
				}
			}
			if(zap > -1) {
				sprintf(iodata, "%s/%s", urlbase, local);
				zap = getfile(result->hostname, iodata, port, result->hostip, local);
			}
		}
		fclose(ls);
bail:
		FREE(result->hostip);
		FREE(result->hostname);
		FREE(result);
		if(dotcount) printf("\n\n\n\n\n\n\n\n\n\nUpdate updated, please re-run this program!\n");

	}

#ifndef CPM
#ifndef z80
#ifndef HI_TECH_C
	exit(0);
#endif
#endif
#endif
}


/* tell link parser who we are and where we belong


0000 update.com update.obj xxPROGRAMxx

*/

